"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var mensagem_1 = require("./modelo/mensagem");
var tipo_mensagem_1 = require("./modelo/tipo-mensagem");
var post_message_api_1 = require("./post-message-api");
var BridgeRestApi = /** @class */ (function () {
    function BridgeRestApi() {
        this.postMessage = new post_message_api_1.PostMessageApi();
    }
    /************************************************
     *         Métodos disponíveis na API
     ************************************************/
    /************************************************
     *               Obtendo dados
     ************************************************/
    BridgeRestApi.prototype.obterDadosGenericos = function (chave) {
        if (chave === void 0) { chave = this.required('obterDadosGenericos'); }
        this.postMessage.enviarMensagem(new mensagem_1.MensagemAPI(tipo_mensagem_1.TipoMensagemAPI.OBTEM_DADOS_GENERICOS, { chave: chave }));
    };
    BridgeRestApi.prototype.obterUltimaPaginaAcessada = function () {
        this.postMessage.enviarMensagem(new mensagem_1.MensagemAPI(tipo_mensagem_1.TipoMensagemAPI.OBTEM_ULTIMA_PAGINA_ACESSADA));
    };
    BridgeRestApi.prototype.obterDadosConclusaoUnidade = function (identificadorUnidade) {
        if (identificadorUnidade === void 0) { identificadorUnidade = this.required('obterDadosConclusaoUnidade'); }
        this.postMessage.enviarMensagem(new mensagem_1.MensagemAPI(tipo_mensagem_1.TipoMensagemAPI.OBTEM_DADOS_CONCLUSAO_UNIDADE, { identificadorUnidade: identificadorUnidade }));
    };
    BridgeRestApi.prototype.obterConfiguracaoAtividade = function (identificadorAtividade) {
        if (identificadorAtividade === void 0) { identificadorAtividade = this.required('obterConfiguracaoAtividade'); }
        this.postMessage.enviarMensagem(new mensagem_1.MensagemAPI(tipo_mensagem_1.TipoMensagemAPI.OBTEM_CONFIGURACAO_ATIVIDADE, { identificadorAtividade: identificadorAtividade }));
    };
    BridgeRestApi.prototype.obterRespostaAtividade = function (identificadorAtividade) {
        if (identificadorAtividade === void 0) { identificadorAtividade = this.required('obterRespostaAtividade'); }
        this.postMessage.enviarMensagem(new mensagem_1.MensagemAPI(tipo_mensagem_1.TipoMensagemAPI.OBTEM_RESPOSTA_ATIVIDADE, { identificadorAtividade: identificadorAtividade }));
    };
    BridgeRestApi.prototype.obterDadosConclusaoFormacao = function () {
        this.postMessage.enviarMensagem(new mensagem_1.MensagemAPI(tipo_mensagem_1.TipoMensagemAPI.OBTEM_DADOS_CONCLUSAO_FORMACAO));
    };
    BridgeRestApi.prototype.obterConfiguracaoConclusaoUnidade = function (identificadorUnidade) {
        if (identificadorUnidade === void 0) { identificadorUnidade = this.required('obterConfiguracaoConclusaoUnidade'); }
        this.postMessage.enviarMensagem(new mensagem_1.MensagemAPI(tipo_mensagem_1.TipoMensagemAPI.OBTEM_DADOS_CONFIGURACAO_CONCLUSAO_UNIDADE, { identificadorUnidade: identificadorUnidade }));
    };
    BridgeRestApi.prototype.obterSeExisteProximaUnidade = function (identificadorUnidade) {
        if (identificadorUnidade === void 0) { identificadorUnidade = this.required('obterSeExisteProximaUnidade'); }
        this.postMessage.enviarMensagem(new mensagem_1.MensagemAPI(tipo_mensagem_1.TipoMensagemAPI.OBTEM_SE_EXISTE_PROXIMA_UNIDADE, { identificadorUnidade: identificadorUnidade }));
    };
    BridgeRestApi.prototype.obterProximaUnidade = function (identificadorUnidade) {
        if (identificadorUnidade === void 0) { identificadorUnidade = this.required('obterProximaUnidade'); }
        this.postMessage.enviarMensagem(new mensagem_1.MensagemAPI(tipo_mensagem_1.TipoMensagemAPI.OBTEM_PROXIMA_UNIDADE, { identificadorUnidade: identificadorUnidade }));
    };
    BridgeRestApi.prototype.obterStatusContraste = function () {
        this.postMessage.enviarMensagem(new mensagem_1.MensagemAPI(tipo_mensagem_1.TipoMensagemAPI.OBTEM_STATUS_CONTRASTE));
    };
    /************************************************
     *                  Salvando dados
     ************************************************/
    BridgeRestApi.prototype.registrarDadosGenericos = function (chave, valor) {
        if (chave === void 0) { chave = this.required('registrarDadosGenericos'); }
        if (valor === void 0) { valor = this.required('registrarDadosGenericos'); }
        this.postMessage.enviarMensagem(new mensagem_1.MensagemAPI(tipo_mensagem_1.TipoMensagemAPI.REGISTRA_DADOS_GENERICOS, { chave: chave, valor: valor }));
    };
    BridgeRestApi.prototype.registrarUltimaPaginaAcessada = function (identificadorUnidade, urlUltimaPaginaAcessada) {
        if (identificadorUnidade === void 0) { identificadorUnidade = this.required('registrarUltimaPaginaAcessada'); }
        urlUltimaPaginaAcessada = !urlUltimaPaginaAcessada ? window.location.pathname : window.location.pathname.split("/").slice(0, 5).join("/") + "/" + urlUltimaPaginaAcessada;
        this.postMessage.enviarMensagem(new mensagem_1.MensagemAPI(tipo_mensagem_1.TipoMensagemAPI.REGISTRA_ULTIMA_PAGINA_ACESSADA, { identificadorUnidade: identificadorUnidade, urlUltimaPaginaAcessada: urlUltimaPaginaAcessada }));
    };
    BridgeRestApi.prototype.registrarPorcentagemConclusaoUnidade = function (identificadorUnidade, porcentagem) {
        if (identificadorUnidade === void 0) { identificadorUnidade = this.required('registrarPorcentagemConclusaoUnidade'); }
        if (porcentagem === void 0) { porcentagem = this.required('registrarPorcentagemConclusaoUnidade'); }
        this.postMessage.enviarMensagem(new mensagem_1.MensagemAPI(tipo_mensagem_1.TipoMensagemAPI.REGISTRA_PORCENTAGEM_CONCLUSAO_UNIDADE, { identificadorUnidade: identificadorUnidade, porcentagem: porcentagem }));
    };
    BridgeRestApi.prototype.registrarRespostaAtividade = function (atividade) {
        if (atividade === void 0) { atividade = this.required('registrarRespostaAtividade'); }
        this.postMessage.enviarMensagem(new mensagem_1.MensagemAPI(tipo_mensagem_1.TipoMensagemAPI.REGISTRA_RESPOSTA_ATIVIDADE, atividade));
    };
    BridgeRestApi.prototype.required = function (metodo) {
        throw new Error('Todos os parâmetros da função ' + metodo + ' são obrigatórios.');
    };
    return BridgeRestApi;
}());
exports.BridgeRestApi = BridgeRestApi;
//# sourceMappingURL=index.js.map